diff --git a/src/ChmModel.cpp b/src/ChmModel.cpp
index 3a50170fe64..4b2c3404aff 100644
--- a/src/ChmModel.cpp
+++ b/src/ChmModel.cpp
@@ -19,7 +19,6 @@
 #include "GlobalPrefs.h"
 #include "ChmModel.h"
 
-
 static TocItem* NewChmTocItem(TocItem* parent, const WCHAR* title, int pageNo, const WCHAR* url) {
     auto res = new TocItem(parent, title, pageNo);
     if (!url) {
diff --git a/src/EngineMupdf.cpp b/src/EngineMupdf.cpp
index b0dcaae591e..0292c09526c 100644
--- a/src/EngineMupdf.cpp
+++ b/src/EngineMupdf.cpp
@@ -1882,7 +1882,7 @@ bool EngineMupdf::LoadFromStream(fz_stream* stm, const char* nameHint, PasswordU
         lfontDy = 8.f;
     }
 
-	if (custom_css) {
+    if (custom_css) {
         fz_set_user_css(ctx, custom_css);
     }
 
@@ -2360,6 +2360,8 @@ TocTree* EngineMupdf::GetToc() {
 
     int idCounter = 0;
 
+    ScopedCritSec cs(ctxAccess);
+
     TocItem* root = nullptr;
     TocItem* att = nullptr;
     if (outline) {
@@ -2772,7 +2774,7 @@ RenderedBitmap* EngineMupdf::RenderPage(RenderPageArgs& args) {
             // TODO: to have uniform background needs to set custom css
             // background-color and clear pixmap with the same color
             fz_clear_pixmap_with_value(ctx, pix, 0xff);
-            //fz_clear_pixmap(ctx, pix);
+            // fz_clear_pixmap(ctx, pix);
             // fz_fill_pixmap_with_color(ctx, pix, )
             dev = fz_new_draw_device(ctx, ctm, pix);
             fz_run_page_contents(ctx, page, dev, fz_identity, NULL);
diff --git a/src/docs/log.txt b/src/docs/log.txt
index a05b2bd7cb9..504627d2e4a 100644
--- a/src/docs/log.txt
+++ b/src/docs/log.txt
@@ -1,5 +1,11 @@
 A daily log of changes and commentary. An experiment of sorts.
 
+2021-11-05 Fri
+
+- take access lock in GetToc() (fixes #2229)
+  https://github.com/sumatrapdfreader/sumatrapdf/issues/2229
+  there might be more locking lacking
+
 2021-10-26 Tue
 
 - fix pdf_resolve_link (fixes #2216)
